#
#  Copyright (c) 2005 Helmut Merz helmutm@cy55.de
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

"""
Definition of the Concept class.

$Id$
"""

from zope.app import zapi
from zope.app.container.btree import BTreeContainer
from zope.app.container.contained import Contained
from zope.interface import implements
from persistent import Persistent
from cybertools.relation.registry import getRelations

from interfaces import IResource, IDocument
from interfaces import IResourceManager, IResourceManagerContained
from interfaces import ILoopsContained


class Resource(Contained, Persistent):

    implements(IResource, IResourceManagerContained)

    _title = u''
    def getTitle(self): return self._title
    def setTitle(self, title): self._title = title
    title = property(getTitle, setTitle)

    def __init__(self, title=u''):
        self.title = title

    def getClients(self, relationships=None):
        rels = getRelations(second=self, relationships=relationships)
        return [r.first for r in rels]


class Document(Resource):

    implements(IDocument)
        
    _body = u''
    def setBody(self, body): self._body = body
    def getBody(self): return self._body
    body = property(getBody, setBody)

    _format = u'text/xml'
    def setFormat(self, format): self._format = format
    def getFormat(self): return self._format
    format = property(getFormat, setFormat)


class ResourceManager(BTreeContainer):

    implements(IResourceManager, ILoopsContained)


